﻿Imports System.Drawing.Imaging
Imports System.Drawing
Imports System.Drawing.Drawing2D
Module Bildverarbeitung


    ''' <summary>
    ''' Umwandeln eines Bildes in SW 
    ''' </summary>
    ''' <returns></returns>
    Public Function Save_SW_Picture()
        ' Laden Sie das Bild in einem Bitmap-Objekt
        Dim bmp As New Bitmap("e:\1679571552280.jpg")

        ' Erstellen Sie eine neue ColorMatrix
        Dim grayMatrix As New ColorMatrix(New Single()() {
        New Single() {0.2126F, 0.2126F, 0.2126F, 0, 0},
        New Single() {0.7152F, 0.7152F, 0.7152F, 0, 0},
        New Single() {0.0722F, 0.0722F, 0.0722F, 0, 0},
        New Single() {0, 0, 0, 1, 0},
        New Single() {0, 0, 0, 0, 1}
        })

        ' Erstellen Sie ein neues ImageAttributes-Objekt
        Dim attr As New ImageAttributes()

        ' Setzen Sie das Farbmatrixattribut des ImageAttributes-Objekts auf das ColorMatrix-Objekt
        attr.SetColorMatrix(grayMatrix)

        ' Erstellen Sie ein neues Bitmap-Objekt, um das Graustufenbild zu halten
        Dim grayBmp As New Bitmap(bmp.Width, bmp.Height)

        ' Zeichnen Sie das ursprüngliche Bitmap-Objekt auf das neue Bitmap-Objekt unter Verwendung des ImageAttributes-Objekts
        Using g As Graphics = Graphics.FromImage(grayBmp)
            g.DrawImage(bmp, New Rectangle(0, 0, bmp.Width, bmp.Height),
                0, 0, bmp.Width, bmp.Height, GraphicsUnit.Pixel, attr)
        End Using

        ' Speichern Sie das Graustufenbild
        grayBmp.Save("e:\grauBild.BMP", ImageFormat.Bmp)

        ' Freigeben von Ressourcen
        bmp.Dispose()
        grayBmp.Dispose()
        attr.Dispose()


    End Function

    ''' <summary>
    ''' Funktion CropBitmap
    ''' </summary>
    ''' <param name="bmp"></param>
    ''' <param name="cropX"></param>
    ''' <param name="cropY"></param>
    ''' <param name="cropWidth"></param>
    ''' <param name="cropHeight"></param>
    ''' <returns></returns>
    Private Function CropBitmap(ByRef bmp As Bitmap, ByVal cropX As Integer, ByVal cropY As Integer, ByVal cropWidth As Integer, ByVal cropHeight As Integer) As Bitmap
        Dim rect As New Rectangle(cropX, cropY, cropWidth, cropHeight)
        Dim cropped As Bitmap = bmp.Clone(rect, bmp.PixelFormat)
        Return cropped
    End Function
    ''' <summary>
    ''' Schneidet ein Bild um die Linie Herum aus
    ''' </summary>
    ''' <param name="imagePath"></param>
    ''' <param name="linePoints"></param>
    ''' <param name="outputImagePath"></param>
    Private Sub CropImageRectangleAroundLine(imagePath As String, linePoints As List(Of Point), width As Integer, outputImagePath As String)
        ' Laden des Bildes
        Dim image As New Bitmap(imagePath)

        ' Bestimmen des Bereichs um die Linie herum
        Dim minX As Integer = linePoints.Min(Function(p) p.X) - width
        Dim minY As Integer = linePoints.Min(Function(p) p.Y) - width
        Dim maxX As Integer = linePoints.Max(Function(p) p.X) + width
        Dim maxY As Integer = linePoints.Max(Function(p) p.Y) + width

        ' Erweitern des Bereichs auf den Bildgrenzen
        minX = Math.Max(minX, 0)
        minY = Math.Max(minY, 0)
        maxX = Math.Min(maxX, image.Width - 1)
        maxY = Math.Min(maxY, image.Height - 1)

        ' Ausschneiden des Bildes mit dem erweiterten Bereich
        Dim croppedImage As Bitmap = image.Clone(New Rectangle(minX, minY, maxX - minX + 1, maxY - minY + 1), image.PixelFormat)

        ' Speichern des ausgeschnittenen Bildes
        croppedImage.Save(outputImagePath)

        ' Freigeben der Ressourcen
        image.Dispose()
        croppedImage.Dispose()
    End Sub
    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="imagePath"></param>
    ''' <param name="linePoints"></param>
    ''' <param name="outputImagePath"></param>
    Public Sub CropImageAlongCurve(imagePath As String, linePoints As List(Of Point), outputImagePath As String)
        ' Laden des Bildes
        Dim image As New Bitmap(imagePath)
        Dim point As List(Of Point) = linePoints
        ' Erstellen eines GraphicsPath, um die Kurve zu definieren
        Dim path As New GraphicsPath()
        Dim linePointBorder As New List(Of Point)
        For I = 0 To linePoints.Count - 1 Step 1
            point(I) = New Point(linePoints(I).X, linePoints(I).Y - 10)
        Next
        For I = 0 To linePoints.Count - 1 Step 1
            linePointBorder.Add(point(I))
        Next
        For I = 0 To linePoints.Count - 1 Step 1
            point(I) = New Point(linePoints(I).X, linePoints(I).Y + 10)
        Next
        For I = linePoints.Count - 1 To 0 Step -1
            linePointBorder.Add(point(I))
        Next


        path.AddCurve(linePointBorder.ToArray())

        ' Erstellen einer leeren Bitmap mit derselben Größe wie das Eingangsbild
        Dim croppedImage As New Bitmap(image.Width, image.Height)

        ' Zeichnen der Kurve auf die leere Bitmap
        Using g As Graphics = Graphics.FromImage(croppedImage)
            g.SmoothingMode = SmoothingMode.AntiAlias
            g.DrawPath(Pens.White, path)
            g.FillPath(Brushes.White, path)
        End Using

        ' Ausschneiden des Bildes anhand der Kurve
        Using result As New Bitmap(croppedImage.Width, croppedImage.Height)
            Using g As Graphics = Graphics.FromImage(result)
                g.DrawImage(image, 0, 0)
                g.CompositingMode = CompositingMode.SourceOver
                g.DrawImage(croppedImage, 0, 0)
            End Using

            ' Speichern des ausgeschnittenen Bildes
            result.Save(outputImagePath)
        End Using

        ' Freigeben der Ressourcen
        image.Dispose()
        croppedImage.Dispose()
    End Sub


    ''' <summary>
    ''' Collect all Pixelcolors
    ''' </summary>
    ''' <param name="BMP"></param>
    ''' <returns>2D Color Array all PixelColors</returns>
    Public Function Get_Intensitys(ByVal BMP As Bitmap) As Color(,)
        Dim width As Integer = BMP.Width
        Dim height As Integer = BMP.Height
        ' Erstellen Sie das 2D-Array
        Dim colorArray(width - 1, height - 1) As Color
        'Dim sourceRect As New Rectangle(150, 110, 4000, 50)

        ' Füllen Sie das Array mit Farbwerten
        For x As Integer = 0 To width - 1
            For y As Integer = 0 To height - 1
                colorArray(x, y) = BMP.GetPixel(x, y)
                'colorArray(x, y) = Color.FromArgb(255, x Mod 256, y Mod 256, (x + y) Mod 256)
            Next
        Next
        Get_Intensitys = colorArray

    End Function



    Public Function Auswerten_Auf_Y_Linie_Brigthness(ByVal Input As Bitmap) As Double()
        Dim width As Integer = Input.Width
        Dim height As Integer = Input.Height
        ' Erstellen Sie das 2D-Array
        Dim grayArray(Input.Width - 1) As Double
        Dim colorArray(width - 1, height - 1) As Color

        ' Füllen Sie das Array mit Farbwerten
        For x As Integer = 0 To width - 1
            For y As Integer = 0 To height - 1
                colorArray(x, y) = Input.GetPixel(x, y)
            Next
        Next
        Dim LineBrightness As Double = 0

        ' Konvertieren Sie die Farbwerte in Grauwerte
        For x As Integer = 0 To width - 1
            LineBrightness = 0
            For y As Integer = 0 To height - 1
                LineBrightness = LineBrightness + colorArray(x, y).GetBrightness()
            Next
            grayArray(x) = LineBrightness * 10  ' Normierung 0-100
        Next

        Auswerten_Auf_Y_Linie_Brigthness = grayArray

    End Function
    Public Function ComputeMovingAverage(dataArray As Double(), windowSize As Integer) As Double()
        Dim size As Integer = dataArray.Length
        Dim averagedArray(size - 1) As Double
        Dim sum As Double = 0
        Dim count As Integer = 0
        For i As Integer = 0 To size - 1
            sum += dataArray(i)
            count += 1
            If count > windowSize Then
                sum -= dataArray(i - windowSize)
                count -= 1
            End If
            If count >= windowSize Then
                averagedArray(i) = sum / windowSize
            End If
        Next
        Return averagedArray
    End Function


    Public Sub GenerateMaskAndSaveImage(inputImagePath As String, outputMaskPath As String, Threashhold As Single)
        ' Laden des Eingangsbildes
        Dim inputImage As New Bitmap(inputImagePath)

        ' Erstellen einer leeren Maske mit der gleichen Größe wie das Eingangsbild
        Dim mask As New Bitmap(inputImage.Width, inputImage.Height)

        ' Schleife durch jeden Pixel des Eingangsbildes
        For y As Integer = 0 To inputImage.Height - 1
            For x As Integer = 0 To inputImage.Width - 1
                ' Abrufen der Farbe des aktuellen Pixels
                Dim pixelColor As Color = inputImage.GetPixel(x, y)

                ' Überprüfen der Helligkeit des Pixels
                Dim brightness As Integer = CInt(pixelColor.R) + CInt(pixelColor.G) + CInt(pixelColor.B)
                Dim Intensity As Single = pixelColor.GetBrightness
                If Intensity < Threashhold Then
                    ' Setzen des Pixels in der Maske auf Schwarz (ausschneiden)
                    mask.SetPixel(x, y, Color.Black)
                Else
                    ' Setzen des Pixels in der Maske auf Weiß (behalten)
                    mask.SetPixel(x, y, Color.White)
                End If

                'If brightness < 100 Then
                '    ' Setzen des Pixels in der Maske auf Schwarz (ausschneiden)
                '    mask.SetPixel(x, y, Color.Black)
                'Else
                '    ' Setzen des Pixels in der Maske auf Weiß (behalten)
                '    mask.SetPixel(x, y, Color.White)
                'End If
            Next
        Next

        ' Speichern der Maske als neues Bild
        mask.Save(outputMaskPath)
        mask.Clone()
        inputImage.Clone()
    End Sub


End Module
